package iot

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// StartAIBoxForceSync invokes the iot.StartAIBoxForceSync API synchronously
func (client *Client) StartAIBoxForceSync(request *StartAIBoxForceSyncRequest) (response *StartAIBoxForceSyncResponse, err error) {
	response = CreateStartAIBoxForceSyncResponse()
	err = client.DoAction(request, response)
	return
}

// StartAIBoxForceSyncWithChan invokes the iot.StartAIBoxForceSync API asynchronously
func (client *Client) StartAIBoxForceSyncWithChan(request *StartAIBoxForceSyncRequest) (<-chan *StartAIBoxForceSyncResponse, <-chan error) {
	responseChan := make(chan *StartAIBoxForceSyncResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.StartAIBoxForceSync(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// StartAIBoxForceSyncWithCallback invokes the iot.StartAIBoxForceSync API asynchronously
func (client *Client) StartAIBoxForceSyncWithCallback(request *StartAIBoxForceSyncRequest, callback func(response *StartAIBoxForceSyncResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *StartAIBoxForceSyncResponse
		var err error
		defer close(result)
		response, err = client.StartAIBoxForceSync(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// StartAIBoxForceSyncRequest is the request struct for api StartAIBoxForceSync
type StartAIBoxForceSyncRequest struct {
	*requests.RpcRequest
	IotId       string `position:"Query" name:"IotId"`
	ApiProduct  string `position:"Body" name:"ApiProduct"`
	ApiRevision string `position:"Body" name:"ApiRevision"`
}

// StartAIBoxForceSyncResponse is the response struct for api StartAIBoxForceSync
type StartAIBoxForceSyncResponse struct {
	*responses.BaseResponse
	RequestId    string `json:"RequestId" xml:"RequestId"`
	Success      bool   `json:"Success" xml:"Success"`
	ErrorMessage string `json:"ErrorMessage" xml:"ErrorMessage"`
	Code         string `json:"Code" xml:"Code"`
	Data         bool   `json:"Data" xml:"Data"`
}

// CreateStartAIBoxForceSyncRequest creates a request to invoke StartAIBoxForceSync API
func CreateStartAIBoxForceSyncRequest() (request *StartAIBoxForceSyncRequest) {
	request = &StartAIBoxForceSyncRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Iot", "2018-01-20", "StartAIBoxForceSync", "iot", "openAPI")
	request.Method = requests.POST
	return
}

// CreateStartAIBoxForceSyncResponse creates a response to parse from StartAIBoxForceSync response
func CreateStartAIBoxForceSyncResponse() (response *StartAIBoxForceSyncResponse) {
	response = &StartAIBoxForceSyncResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
